<?php
/** 
* Polish Language File developed by mybboard.pl for NewPoints Shop 1.6
* Tłumaczenie: Vectrom
* Poprawki: Ekipa Polskiego Supportu MyBB (mybboard.pl)
* Wersja 1.0
**/

/***************************************************************************
 *
 *   Converter to convert MyPlaza Turbo Inventory items to NewPoints Shop items(/converter.php)
 *	 Author: Pirata Nervo
 *   Copyright: © 2009-2011 Pirata Nervo
 *   
 *   Website: http://www.mybb-plugins.com
 *
 *   Integrates a Shop system with NewPoints.
 *
 ***************************************************************************/
 
/****************************************************************************
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************************/

define("IN_MYBB", 1);
define('THIS_SCRIPT', 'converter.php');

// Templates used by the converter
$template_home = '<html>
<head>
<title>NewPoints Shop - konwerter</title>
{$headerinclude}
</head>
<body>
{$header}
<form action="converter.php" method="POST">
<input type="hidden" name="postcode" value="{$mybb->post_code}">
<input type="hidden" name="action" value="do_process1">
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
<tr>
<td class="thead"><strong>Konwertowanie MyPlaza Turbo Items do NewPoints Shop Items</strong></td>
</tr>
<tr>
<td class="trow1" width="100%">Ten konwerter przetwarza następujące dane:<br /><ul><li>Przedmioty</li></ul><br />Proces konwersji nie doda przedmiotów zakupionych przez użytkowników!</td>
</tr>
<tr>
<td class="tfoot" width="100%" colspan="2" align="center"><input type="submit" name="submit" value="Kontynuuj"></td>
</tr>
</table>
</form>
{$footer}
</body>
</html>';

$template_process1 = '<html>
<head>
<title>NewPoints Shop - konwerter</title>
{$headerinclude}
</head>
<body>
{$header}
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder">
<tr>
<td class="thead"><strong>Konwersja MyPlaza Turbo Items do NewPoints Shop Items</strong></td>
</tr>
<tr>
<td class="trow1" width="100%">Dokonano konwersji i przeniesienia {$count} przedmiotów do kategorii nazwanej "Skonwertowane przedmioty" (ta kategoria dostępna jest wyłącznie z panelu administracyjnego).<br />Gratulacje, pomyślnie przekonwertowano MyPlaza Turbo Inventory Items do NewPoints Shop Items.<br />Pamiętaj, że inwentarze i kategorie nie zostały skonwertowane!<br /><strong>Ikony przedmiotów należy przenieść do images/newpoints/.</strong></td>
</tr>
</table>
{$footer}
</body>
</html>';

require_once "./global.php";

if (!$mybb->input['action'])
{
	eval("\$page = \"".str_replace("\\'", "'", addslashes($template_home))."\";");
	
	output_page($page);
}
elseif ($mybb->input['action'] == 'do_process1')
{
	verify_post_check($mybb->input['postcode']);
	
	$count = 0;
	
	// create new category for converted items
	$insert_query = array('name' => 'Skonwertowane przedmioty', 'description' => 'Jest to kategoria, w której zostały umieszczone skonwertowane przedmioty.', 'usergroups' => '', 'visible' => 0, 'disporder' => 1, 'icon' => '', 'expanded' => 1);
	
	$cid = $db->insert_query('newpoints_shop_categories', $insert_query);
	
	/*$query = $db->query("
		SELECT i.*, iv.*
		FROM ".TABLE_PREFIX."plaza_items i
		LEFT JOIN ".TABLE_PREFIX."plaza_inventory_items iv ON (iv.iid=i.iid)
	");*/
	$query = $db->query("
		SELECT iv.*, i.*
		FROM ".TABLE_PREFIX."plaza_inventory_items iv
		LEFT JOIN ".TABLE_PREFIX."plaza_items i ON (i.iid=iv.iid)
	");
	while ($item = $db->fetch_array($query))
	{
		$insert_array = array();
		$insert_array['name'] = $db->escape_string($item['name']);
		$insert_array['description'] = $db->escape_string($item['description']);
		$insert_array['icon'] = "images/newpoints/".$db->escape_string($item['icon']);
		$insert_array['price'] = floatval($item['cost']);
		$insert_array['cid'] = intval($cid);
		$insert_array['visible'] = intval($item['visible']);
		$insert_array['disporder'] = intval($item['disporder']);
		$insert_array['infinite'] = 1;
		$insert_array['stock'] = 0;
		$insert_array['sendable'] = intval($item['sendable']);
		$insert_array['sendable'] = intval($item['sellable']);
		
		$db->insert_query('newpoints_shop_items', $insert_array);
		$count++;
	}
	
	$db->update_query('newpoints_shop_categories', array('items' => $count), 'cid=\''.$cid.'\'');
	
	eval("\$page = \"".str_replace("\\'", "'", addslashes($template_process1))."\";");
	
	output_page($page);
}

exit;

?>